#!/usr/bin/perl
use PDA::Pilot; # from the pilot-link package.
use POSIX qw(mktime);

sub UInt32
{
  return sprintf("%c%c%c%c", ($_[0] & 0xff000000)>>24,
		 ($_[0] & 0xff0000)>>16,
		 ($_[0] & 0xff00)>>8,
		 ($_[0] & 0xff));
}

sub UInt16
{
  return sprintf("%c%c", ($_[0] & 0xff00)>>8,
		 ($_[0] & 0xff));
}

$secs_since_70 = 24107 * 86400 - 28800; # + 3600;
$state = 0;

%info = ("type"=>"Data","creator"=>"tpWC","name"=>"worldcupDB");
$pdb = PDA::Pilot::File::create("worldcupDB.pdb", \%info )
  or die "something went wrong\n";

$rec = "\1";
$pdb->addRecordRaw($rec,0,0,0);
$rec = "";

%posEnum = ('G'=>0,'D'=>1,'M'=>2,'F'=>3,'C'=>4);

while(<STDIN>) {
  chomp();
  next if (/^\s*#/);

  if (/^$/) {
    $state++;
    $pdb->addRecordRaw($rec,$state,0,0);
    $rec = "";
    next;
  }

  if ($state == 0) {
    @args = split(/:/);
    $date = "";
    if ($args[6] && $args[6] =~ /^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})/) {
      $date = mktime(0, $5, $4, $3, $2-1, $1-1900) + $secs_since_70;
    }
    $args[6] = UInt32($date);
    $args[3] = 255 if ($args[3] == -1);
    $args[4] = 255 if ($args[4] == -1);
    $rec .= sprintf("%c%c%c%c%c%c%s", @args);
  }

  if ($state == 1) {
    @args = split(/:/);
    $rec .= $args[0] . "\0" x (10-length($args[0])) . UInt32($args[1]);
  }

  if ($state == 2) {
    @args = split(/\|/);
    $rec .= $args[0] . "\0" x (20-length($args[0])) . 
            $args[1] . "\0" x (80-length($args[1]));
  }

  if ($state > 2) {
    @args = split(/:/);
    next if ($#args<3);
    if ($args[3] && $args[3] =~ /^(\d{4})(\d{2})(\d{2})/) {
      $date = $3 + ($2<<5) + (($1-1904)<<9);
    }

    next if (length($args[1])>26 or length($args[2]>26));
    $rec .= $args[1] . "\0" x (26-length($args[1])) .
            $args[2] . "\0" x (26-length($args[2])) .
            UInt16($date) .
            chr($posEnum{$args[0]}) . "\0";
  }

}

