#ifndef _WORLDCUP_H_
#define _WORLDCUP_H_

/*
 * utils.c
 */
char* GetString(UInt16 id);
void DisplayErrorMessage(UInt16 id);
void DisplayInformationMessage(UInt16 id);
UInt16 DisplayConfirmationMessage(UInt16 id);
void* Id2Ptr(UInt16 id);
void SetHandleInt(FieldType* fptr, Int32 n);
void SetTextFieldWithHandle(FieldPtr textFldP, MemHandle textH, Boolean drawIt);
Err SetTextFieldWithString(FieldPtr textFldP, char *string, Boolean drawIt);

/*
 * worldcup.c
 */
typedef struct {
  Int16 version;
  Int16 options;
  Int32 gmtOff;
  Int16 group, round;
} MyAppPreferencesType;

struct spiel {
  UInt8 gruppe, m1, m2;
  Int8 e1, e2;
  UInt8 ort;
  UInt32 datum;
};

struct player {
  char name[26];
  char team[26];
  DateType dateBirth;
  enum { Goal, Defense, Midfield, Forward, Coach } position;
};

struct team {
  char name[20];
  char info[80];
};

struct ort {
  char name[10];
  UInt32 cap;
};

struct mstatus {
  UInt16 Tore, GTore, Pkte;
  Int8 Spiele, Platz, Gew, Rem, Ver;
};

struct match {
  FieldType *m1, *m2, *e1, *e2, *num;
  UInt8 team1, team2, team1Final, team2Final;
  Int8 erg1, erg2, ort;
  UInt32 datum;
  UInt8 recNo;
};

Int8 ComputeTable(struct mstatus *table, struct match *match,
		  Int8 who, Int8 recursive);
void ReadSetFixture(struct match* match, UInt8 group, Boolean setallfields);
Boolean TimezoneFormHandleEvent(EventPtr e);
Boolean AboutFormHandleEvent(EventPtr e);
Boolean SpieltagFormHandleEvent(EventPtr e);

extern UInt8 selectedTeam;
extern UInt8 selectedStadium;
extern Int32 defaultDateFormat;
extern MyAppPreferencesType appPrefs;

/*
 * database.c
 */
struct prefs {
  UInt8 version;
};
extern struct prefs thePrefs;
extern DmOpenRef worldcupDB, worldcupPics, datebook;

Boolean OpenDatebook(void);
Boolean OpenDatabase(void);
char* ReadFixture(char*, struct spiel*);
void WriteFixture(struct match *match, UInt8 num, UInt8 group);
void SetHandleString(FieldType *fptr, int num);
UInt8 ComputeSetHandleString(FieldType *fptr, int num);
struct team* GetTeamString(int num);
UInt32 SetOrtString(Int16 id, int num);
UInt16 readPlayers(char *items[], UInt16 selectedTeam);

/*
 * teams.c
 */
Boolean TeamsFormHandleEvent(EventPtr e);
Boolean PlayerFormHandleEvent(EventPtr e);

/*
 * stadium.c
 */
Boolean ShowStadiumFormHandleEvent(EventPtr e);

/*
 * matches.c
 */
Boolean MatchesFormHandleEvent(EventPtr e);

#endif
